

# EnableControl
<a name="API_EnableControl"></a>

This API call activates a control. It starts an asynchronous operation that creates AWS resources on the specified organizational unit and the accounts it contains. The resources created will vary according to the control that you specify. For usage examples, see the [https://docs.aws.amazon.com/controltower/latest/controlreference/control-api-examples-short.html](https://docs.aws.amazon.com/controltower/latest/controlreference/control-api-examples-short.html).

## Request Syntax
<a name="API_EnableControl_RequestSyntax"></a>

```
POST /enable-control HTTP/1.1
Content-type: application/json

{
   "controlIdentifier": "string",
   "parameters": [ 
      { 
         "key": "string",
         "value": JSON value
      }
   ],
   "tags": { 
      "string" : "string" 
   },
   "targetIdentifier": "string"
}
```

## URI Request Parameters
<a name="API_EnableControl_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_EnableControl_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [controlIdentifier](#API_EnableControl_RequestSyntax) **   <a name="controltower-EnableControl-request-controlIdentifier"></a>
The ARN of the control. Only **Strongly recommended** and **Elective** controls are permitted, with the exception of the **Region deny** control. For information on how to find the `controlIdentifier`, see [the overview page](https://docs.aws.amazon.com/controltower/latest/APIReference/Welcome.html).  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Pattern: `arn:aws[0-9a-zA-Z_\-:\/]+`   
Required: Yes

 ** [parameters](#API_EnableControl_RequestSyntax) **   <a name="controltower-EnableControl-request-parameters"></a>
A list of input parameter values, which are specified to configure the control when you enable it.  
Type: Array of [EnabledControlParameter](API_EnabledControlParameter.md) objects  
Required: No

 ** [tags](#API_EnableControl_RequestSyntax) **   <a name="controltower-EnableControl-request-tags"></a>
Tags to be applied to the `EnabledControl` resource.  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 200 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Minimum length of 0. Maximum length of 256.  
Required: No

 ** [targetIdentifier](#API_EnableControl_RequestSyntax) **   <a name="controltower-EnableControl-request-targetIdentifier"></a>
The ARN of the organizational unit. For information on how to find the `targetIdentifier`, see [the overview page](https://docs.aws.amazon.com/controltower/latest/APIReference/Welcome.html).  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Pattern: `arn:aws[0-9a-zA-Z_\-:\/]+`   
Required: Yes

## Response Syntax
<a name="API_EnableControl_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "arn": "string",
   "operationIdentifier": "string"
}
```

## Response Elements
<a name="API_EnableControl_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_EnableControl_ResponseSyntax) **   <a name="controltower-EnableControl-response-arn"></a>
The ARN of the `EnabledControl` resource.  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Pattern: `arn:aws[0-9a-zA-Z_\-:\/]+` 

 ** [operationIdentifier](#API_EnableControl_ResponseSyntax) **   <a name="controltower-EnableControl-response-operationIdentifier"></a>
The ID of the asynchronous operation, which is used to track status. The operation is available for 90 days.  
Type: String  
Length Constraints: Fixed length of 36.  
Pattern: `[a-f0-9]{8}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{12}` 

## Errors
<a name="API_EnableControl_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** ConflictException **   
Updating or deleting the resource can cause an inconsistent state.  
HTTP Status Code: 409

 ** InternalServerException **   
An unexpected error occurred during processing of a request.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The request references a resource that does not exist.  
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
The request would cause a service quota to be exceeded. See [Service quotas](https://docs.aws.amazon.com/controltower/latest/userguide/request-an-increase.html).  
HTTP Status Code: 402

 ** ThrottlingException **   
The request was denied due to request throttling.    
 ** quotaCode **   
The ID of the service quota that was exceeded.  
 ** retryAfterSeconds **   
The number of seconds the caller should wait before retrying.  
 ** serviceCode **   
The ID of the service that is associated with the error.
HTTP Status Code: 429

 ** ValidationException **   
The input does not satisfy the constraints specified by an AWS service.  
HTTP Status Code: 400

## See Also
<a name="API_EnableControl_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/controltower-2018-05-10/EnableControl) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/controltower-2018-05-10/EnableControl) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/controltower-2018-05-10/EnableControl) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/controltower-2018-05-10/EnableControl) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/controltower-2018-05-10/EnableControl) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/controltower-2018-05-10/EnableControl) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/controltower-2018-05-10/EnableControl) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/controltower-2018-05-10/EnableControl) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/controltower-2018-05-10/EnableControl) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/controltower-2018-05-10/EnableControl) 